/**
 * LDAPResult.java
 *
 * File generated from the core::LDAPResult uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class LDAPResult.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "LDAPResult", propOrder = {
	"resultCode",
	"errorMessage",
	"referral",
	"matchedDN"
})
@XmlRootElement(name = "LDAPResult")
public class LDAPResult extends net.ihe.gazelle.hpd.DsmlMessage implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "resultCode", required = true, namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.ResultCode resultCode;
	@XmlElement(name = "errorMessage", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public String errorMessage;
	@XmlElement(name = "referral", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public List<String> referral;
	@XmlAttribute(name = "matchedDN")
	public java.lang.String matchedDN;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return resultCode.
	 * @return resultCode
	 */
	public net.ihe.gazelle.hpd.ResultCode getResultCode() {
	    return resultCode;
	}
	
	/**
	 * Set a value to attribute resultCode.
	 * @param resultCode.
	 */
	public void setResultCode(net.ihe.gazelle.hpd.ResultCode resultCode) {
	    this.resultCode = resultCode;
	}
	
	
	
	
	/**
	 * Return errorMessage.
	 * @return errorMessage
	 */
	public String getErrorMessage() {
	    return errorMessage;
	}
	
	/**
	 * Set a value to attribute errorMessage.
	 * @param errorMessage.
	 */
	public void setErrorMessage(String errorMessage) {
	    this.errorMessage = errorMessage;
	}
	
	
	
	
	/**
	 * Return referral.
	 * @return referral
	 */
	public List<String> getReferral() {
		if (referral == null) {
	        referral = new ArrayList<String>();
	    }
	    return referral;
	}
	
	/**
	 * Set a value to attribute referral.
	 * @param referral.
	 */
	public void setReferral(List<String> referral) {
	    this.referral = referral;
	}
	
	
	
	/**
	 * Add a referral to the referral collection.
	 * @param referral_elt Element to add.
	 */
	public void addReferral(String referral_elt) {
	    this.getReferral().add(referral_elt);
	}
	
	/**
	 * Remove a referral to the referral collection.
	 * @param referral_elt Element to remove
	 */
	public void removeReferral(String referral_elt) {
	    this.getReferral().remove(referral_elt);
	}
	
	/**
	 * Return matchedDN.
	 * @return matchedDN
	 */
	public java.lang.String getMatchedDN() {
	    return matchedDN;
	}
	
	/**
	 * Set a value to attribute matchedDN.
	 * @param matchedDN.
	 */
	public void setMatchedDN(java.lang.String matchedDN) {
	    this.matchedDN = matchedDN;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "LDAPResult").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(LDAPResult lDAPResult, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (lDAPResult != null){
   			net.ihe.gazelle.hpd.DsmlMessage.validateByModule(lDAPResult, _location, cvm, diagnostic);
			net.ihe.gazelle.hpd.ResultCode.validateByModule(lDAPResult.getResultCode(), _location + "/resultCode", cvm, diagnostic);
    	}
    }

}